// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/InContainerClassnameFilter.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/InContainerPairFilter.h
 *  \brief A filter for Pairs.
 *
 *  Copyright 2007-2020 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_IN_CONTAINER_PAIR_FILTER_H
#define IMPCONTAINER_IN_CONTAINER_PAIR_FILTER_H

#include <IMP/container/container_config.h>
#include <IMP/PairPredicate.h>
#include <IMP/PairContainer.h>
#include <IMP/internal/container_helpers.h>
#include "internal/PairContainerIndex.h"
#include <IMP/pair_macros.h>
#include <IMP/object_macros.h>
#include <IMP/warning_macros.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! A filter which returns true if a container containers the Pair
/** This predicate returns 1 if the passed tuple is in the container.
    \note Use the handle_permutations parameter to the constructor to
    determine whether only exact matchers, or matches under permutation
    are considered matching. By default they are are.
 */
class IMPCONTAINEREXPORT InContainerPairFilter
    : public PairPredicate {
  IMP::PointerMember<internal::PairContainerIndex> c_;

 public:
  InContainerPairFilter(PairContainer *c,
                             std::string name = "PairFilter %1%");
  InContainerPairFilter(PairContainer *c, bool handle_permutations,
                             std::string name = "PairFilter %1%");

  virtual int get_value_index(Model *, const ParticleIndexPair& vt) const
      IMP_OVERRIDE {
    return c_->get_contains(vt);
  }
  virtual ModelObjectsTemp do_get_inputs(
      Model *m, const ParticleIndexes &pi) const IMP_OVERRIDE {
    ModelObjectsTemp ret = IMP::get_particles(m, pi);
    ret.push_back(c_);
    return ret;
  }
  IMP_PAIR_PREDICATE_METHODS(InContainerPairFilter);
  IMP_OBJECT_METHODS(InContainerPairFilter);
};

IMP_OBJECTS(InContainerPairFilter, InContainerPairFilters);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_IN_CONTAINER_PAIR_FILTER_H */
