// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/MinimumClassnameScore.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/MinimumPairScore.h
 *  \brief Define PairScore.
 *
 *  Copyright 2007-2020 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_MINIMUM_PAIR_SCORE_H
#define IMPCONTAINER_MINIMUM_PAIR_SCORE_H

#include <IMP/container/container_config.h>
#include <IMP/PairScore.h>
#include <IMP/pair_macros.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Evaluate the min or max n particle_pair scores of the passed set
/** Each of the set of PairScores is evaluated and the sum of the
    minimum n is returned.
*/
class IMPCONTAINEREXPORT MinimumPairScore : public PairScore {
  PairScores scores_;
  unsigned int n_;

 public:
  MinimumPairScore(const PairScoresTemp &scores, unsigned int n = 1,
                        std::string name = "PairScore %1%");
  virtual double evaluate_index(Model *m, const ParticleIndexPair& vt,
                                DerivativeAccumulator *da) const IMP_OVERRIDE;
  virtual ModelObjectsTemp do_get_inputs(
      Model *m, const ParticleIndexes &pis) const IMP_OVERRIDE;
  IMP_PAIR_SCORE_METHODS(MinimumPairScore);
  IMP_OBJECT_METHODS(MinimumPairScore);

  Restraints do_create_current_decomposition(Model *m,
                                             const ParticleIndexPair& vt) const
      IMP_OVERRIDE;
};

IMP_OBJECTS(MinimumPairScore, MinimumPairScores);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_MINIMUM_PAIR_SCORE_H */
