// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/core/ClassnameRestraint.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/core/PairRestraint.h
 *  \brief Apply a PairScore to a Pair.
 *
 *  Copyright 2007-2020 IMP Inventors. All rights reserved.
 *
 */

#ifndef IMPCORE_PAIR_RESTRAINT_H
#define IMPCORE_PAIR_RESTRAINT_H

#include <IMP/core/core_config.h>

#include <IMP/internal/TupleRestraint.h>
#include <IMP/PairScore.h>

#include <iostream>

IMPCORE_BEGIN_NAMESPACE

//! Applies a PairScore to a Pair.
/** This restraint stores a Pair.
    \see PairRestraint
 */
class PairRestraint :
#if defined(SWIG) || defined(IMP_DOXYGEN)
    public Restraint
#else
    public IMP::internal::TupleRestraint<PairScore>
#endif
    {
 public:
  //! Create the restraint.
  /** This function takes the function to apply to the
      stored Pair and the Pair.
   */
  PairRestraint(Model *m, PairScore *ss, const ParticleIndexPair& vt,
                     std::string name = "PairRestraint %1%")
      : IMP::internal::TupleRestraint<PairScore>(ss, m, vt, name) {
  }

#if defined(SWIG) || defined(IMP_DOXYGEN)
 protected:
  double unprotected_evaluate(IMP::DerivativeAccumulator *accum) const;
  IMP::ModelObjectsTemp do_get_inputs() const;
  IMP_OBJECT_METHODS(PairRestraint)
#endif
};

IMPCORE_END_NAMESPACE

#endif /* IMPCORE_PAIR_RESTRAINT_H */
