// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/core/ClassnameConstraint.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/core/QuadConstraint.h
 *  \brief Use a QuadModifier applied to a ParticleQuadsTemp to
 *  maintain an invariant
 *
 *  Copyright 2007-2020 IMP Inventors. All rights reserved.
 */

#ifndef IMPCORE_QUAD_CONSTRAINT_H
#define IMPCORE_QUAD_CONSTRAINT_H

#include <IMP/core/core_config.h>
#include <IMP/internal/TupleConstraint.h>
#include <IMP/QuadModifier.h>
#include <IMP/QuadDerivativeModifier.h>

IMPCORE_BEGIN_NAMESPACE
//! Apply a QuadFunction to a Quad
/** The score state is passed up to two QuadModifiers, one to
    apply before evaluation and the other after. The one after
    should take a DerivativeAccumulator as its last argument for
    QuadModifier::apply() and will only be called if
    the score was computed with derivatives.

    \see container::QuadsConstraint
 */
class QuadConstraint :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public Constraint
#else
    public IMP::internal::TupleConstraint<QuadModifier,
                                                  QuadDerivativeModifier>
#endif
    {
 public:
  /** \deprecated_at{2.1} Use the model/index constructor.
   */
  IMPCORE_DEPRECATED_METHOD_DECL(2.1)
  QuadConstraint(QuadModifier *before,
                      QuadDerivativeModifier *after, const ParticleQuad& vt,
                      std::string name = "QuadConstraint %1%")
      : IMP::internal::TupleConstraint<
            QuadModifier, QuadDerivativeModifier>(before, after, vt,
                                                            name) {
    IMPCORE_DEPRECATED_METHOD_DEF(2.1, "Use the model/index constructor.");
  }

  QuadConstraint(QuadModifier *before,
                      QuadDerivativeModifier *after, Model *m,
                      const ParticleIndexQuad& vt,
                      std::string name = "QuadConstraint %1%")
      : IMP::internal::TupleConstraint<
            QuadModifier, QuadDerivativeModifier>(before, after, m,
                                                            vt, name) {}

#if defined(IMP_DOXYGEN) || defined(SWIG)
 protected:
  void do_update_attributes();
  void do_update_derivatives(DerivativeAccumulator *da);
  virtual ModelObjectsTemp do_get_inputs() const;
  virtual ModelObjectsTemp do_get_outputs() const;
  IMP_OBJECT_METHODS(QuadConstraint);
#endif
};

IMPCORE_END_NAMESPACE

#endif /* IMPCORE_QUAD_CONSTRAINT_H */
